CREATE TABLE #temp (orgHier HIERARCHYID, NodeName CHAR(20))

INSERT INTO #temp
        ( orgHier, NodeName )
VALUES  ( '/', -- orgHier - hierarchyid
          'Root'  -- NodeName - char(10)
          )
          
DECLARE @Root HIERARCHYID, @curNode HIERARCHYID
SELECT @Root = hierarchyID::GetRoot()
          
INSERT INTO #temp
        ( orgHier, NodeName )
VALUES  ( @Root.GetDescendant(NULL, NULL), -- orgHier - hierarchyid
          'First child'  -- NodeName - char(10)
          )          
          
SELECT @curNode = MAX(orgHier)
	FROM #temp
	WHERE orgHier.GetAncestor(1) = @Root
	          
INSERT INTO #temp
        ( orgHier, NodeName )
VALUES  ( @curNode.GetDescendant(NULL, NULL), -- orgHier - hierarchyid
          'First grandchild'  -- NodeName - char(10)
          )          
          
INSERT INTO #temp
        ( orgHier, NodeName )
VALUES  ( @Root.GetDescendant(@curNode, NULL), -- orgHier - hierarchyid
          'Second child'  -- NodeName - char(10)
          )          
          
SELECT orgHier, orgHier.ToString(), NodeName FROM #temp

DROP TABLE #temp