DECLARE @iEmpID INT = 37;

WITH EmpHierarchy (FirstName, LastName, ManagerID, EmpLevel) 
AS 
(
SELECT Contact.FirstName, Contact.LastName, Employee.ManagerID, 1 AS EmpLevel
  FROM Person.Contact 
    JOIN HumanResources.Employee
      ON Employee.ContactID = Contact.ContactID
  WHERE EmployeeID = @iEmpID 
UNION ALL
SELECT Contact.FirstName, Contact.LastName, Employee.ManagerID, EmpHierarchy.EmpLevel + 1 AS EmpLevel
  FROM Person.Contact
    JOIN HumanResources.Employee
      ON Employee.ContactID = Contact.ContactID
    JOIN EmpHierarchy
      ON Employee.EmployeeID = EmpHierarchy.ManagerID
)

SELECT FirstName, LastName, EmpLevel
	FROM EmpHierarchy