DECLARE @iEmpID INT = 40;

WITH EmpHierarchy (FirstName, LastName, OrganizationNode, EmpLevel) 
AS 
(
SELECT Person.FirstName, Person.LastName, Employee.OrganizationNode, 1 AS EmpLevel
  FROM Person.Person 
    JOIN HumanResources.Employee
      ON Employee.BusinessEntityID = Person.BusinessEntityID
  WHERE Employee.BusinessEntityID = @iEmpID 
UNION ALL
SELECT Person.FirstName, Person.LastName, Employee.OrganizationNode, EmpHierarchy.EmpLevel + 1 AS EmpLevel
  FROM Person.Person
    JOIN HumanResources.Employee
      ON Employee.BusinessEntityID = Person.BusinessEntityID
    JOIN EmpHierarchy
      ON Employee.OrganizationNode = EmpHierarchy.OrganizationNode.GetAncestor(1)
)

SELECT FirstName, LastName
	FROM EmpHierarchy