SELECT Person.CountryRegion.Name AS Country,
       Person.Address.City,
       YEAR(OrderDate) AS nYear, 
       MONTH(OrderDate) AS nMonth, 
       SUM(SubTotal) AS TotalSales,
       AVG(SubTotal) AS AvgSale,
       COUNT(SubTotal) AS NumSales      
	FROM Sales.Customer
	  JOIN Person.Person
	    ON Customer.PersonID = Person.BusinessEntityID
	  JOIN Person.BusinessEntityAddress
	    ON Person.BusinessEntityID = BusinessEntityAddress.BusinessEntityID
	  JOIN Person.Address
	    ON BusinessEntityAddress.AddressID = Address.AddressID 
	  JOIN Person.StateProvince
	    ON Address.StateProvinceID = StateProvince.StateProvinceID
	  JOIN Person.CountryRegion
	    ON StateProvince.CountryRegionCode = CountryRegion.CountryRegionCode
	  JOIN Sales.SalesOrderHeader
	    ON Customer.CustomerID = SalesOrderHeader.CustomerID
	  JOIN Sales.SalesOrderDetail
	    ON SalesOrderHeader.SalesOrderID = SalesOrderDetail.SalesOrderID	
	GROUP BY GROUPING SETS(
	  (CountryRegion.Name, Address.City, YEAR(OrderDate), MONTH(OrderDate)),
	  (CountryRegion.Name, Address.City, YEAR(OrderDate)),
	  (CountryRegion.Name, Address.City, MONTH(OrderDate)),
	  (CountryRegion.Name, Address.City),
	  (YEAR(OrderDate), MONTH(OrderDate)),
	  (YEAR(OrderDate)),
	  (MONTH(OrderDate)),
	  ())
	ORDER BY Country, City, nYear, nMonth