DECLARE @iEmpID INT = 3;

WITH EmpHierarchy (FirstName, LastName, EmployeeID, EmpLevel, MgrFirst, MgrLast) 
AS 
(
SELECT Contact.FirstName, Contact.LastName, Employee.EmployeeID, 1 AS EmpLevel, 
       CAST('' AS NVARCHAR(50)) AS MgrFirst, CAST('' AS NVARCHAR(50)) AS MgrLast
  FROM Person.Contact 
    JOIN HumanResources.Employee
      ON Employee.ContactID = Contact.ContactID
  WHERE EmployeeID = @iEmpID 
UNION ALL
SELECT Contact.FirstName, Contact.LastName, Employee.EmployeeID, EmpHierarchy.EmpLevel + 1 AS EmpLevel,
       EmpHierarchy.FirstName AS MgrFirst, 
       EmpHierarchy.LastName AS MgrLast
  FROM Person.Contact
    JOIN HumanResources.Employee
      ON Employee.ContactID = Contact.ContactID
    JOIN EmpHierarchy
      ON Employee.ManagerID = EmpHierarchy.EmployeeID
)

SELECT FirstName, LastName, EmpLevel, MgrFirst, MgrLast
	FROM EmpHierarchy