DECLARE @iEmpID INT = 3;

WITH EmpHierarchy (FirstName, LastName, BusinessEntityID, EmpLevel, MgrFirst, MgrLast, OrgNode) 
AS 
(
SELECT Person.FirstName, Person.LastName, Employee.BusinessEntityID, 1 AS EmpLevel, 
       CAST('' AS NVARCHAR(50)) AS MgrFirst, CAST('' AS NVARCHAR(50)) AS MgrLast, 
       OrganizationNode AS OrgNode
  FROM Person.Person 
    JOIN HumanResources.Employee
      ON Employee.BusinessEntityID = Person.BusinessEntityID
  WHERE Employee.BusinessEntityID = @iEmpID 
UNION ALL
SELECT Person.FirstName, Person.LastName, Employee.BusinessEntityID, EmpHierarchy.EmpLevel + 1 AS EmpLevel,
       EmpHierarchy.FirstName AS MgrFirst, 
       EmpHierarchy.LastName AS MgrLast,
       OrganizationNode AS OrgNode
  FROM Person.Person
    JOIN HumanResources.Employee
      ON Employee.BusinessEntityID = Person.BusinessEntityID
    JOIN EmpHierarchy
      ON Employee.OrganizationNode.GetAncestor(1) = EmpHierarchy.OrgNode
)

SELECT FirstName, LastName, EmpLevel, MgrFirst, MgrLast
	FROM EmpHierarchy