CREATE FUNCTION ProductList (@POId INT)
  RETURNS VARCHAR(1000)
  AS 
BEGIN 
	DECLARE @Products VARCHAR(1000)

	SELECT @Products = COALESCE(@Products + ', ', '') + Name 
		FROM (SELECT DISTINCT Name 
			FROM Production.Product
		Inner Join Purchasing.PurchaseOrderDetail As A
					  On Production.Product.ProductID = A.ProductID
		WHERE A.PurchaseOrderID = @POId) DistNames
		ORDER BY Name
                  
RETURN @Products
END 
go 

SELECT DISTINCT PurchaseOrderID, dbo.productList(PurchaseOrderID) AS ProductList
	FROM Purchasing.PurchaseOrderDetail
go 

DROP FUNCTION dbo.ProductList
GO 