SELECT ISNULL(Person.CountryRegion.Name, 'All countries') AS Country,
       ISNULL(Person.Address.City, 'All cities') AS City,
       ISNULL(STR(YEAR(OrderDate)), 'All years') AS OrderYear, 
       ISNULL(STR(MONTH(OrderDate)), 'All months') AS OrderMonth, 
       SUM(SubTotal) AS TotalSales,
       AVG(SubTotal) AS AvgSale,
       COUNT(SubTotal) AS NumSales      
	FROM Sales.Customer
	  JOIN Person.Person
	    ON Customer.PersonID = Person.BusinessEntityID
	  JOIN Person.BusinessEntityAddress
	    ON Person.BusinessEntityID = BusinessEntityAddress.BusinessEntityID
	  JOIN Person.Address
	    ON BusinessEntityAddress.AddressID = Address.AddressID 
	  JOIN Person.StateProvince
	    ON Address.StateProvinceID = StateProvince.StateProvinceID
	  JOIN Person.CountryRegion
	    ON StateProvince.CountryRegionCode = CountryRegion.CountryRegionCode
	  JOIN Sales.SalesOrderHeader
	    ON Customer.CustomerID = SalesOrderHeader.CustomerID
	  JOIN Sales.SalesOrderDetail
	    ON SalesOrderHeader.SalesOrderID = SalesOrderDetail.SalesOrderID	
	GROUP BY ROLLUP(CountryRegion.Name, Address.City, YEAR(OrderDate), MONTH(OrderDate))