SELECT Person.CountryRegion.Name AS Country,
       Person.Address.City,
       null AS nYear, 
       null AS nMonth, 
       SUM(SubTotal) AS TotalSales,
       AVG(SubTotal) AS AvgSale,
       COUNT(SubTotal) AS NumSales      
	FROM Sales.Customer
	  JOIN Person.Person
	    ON Customer.PersonID = Person.BusinessEntityID
	  JOIN Person.BusinessEntityAddress
	    ON Person.BusinessEntityID = BusinessEntityAddress.BusinessEntityID
	  JOIN Person.Address
	    ON BusinessEntityAddress.AddressID = Address.AddressID 
	  JOIN Person.StateProvince
	    ON Address.StateProvinceID = StateProvince.StateProvinceID
	  JOIN Person.CountryRegion
	    ON StateProvince.CountryRegionCode = CountryRegion.CountryRegionCode
	  JOIN Sales.SalesOrderHeader
	    ON Customer.CustomerID = SalesOrderHeader.CustomerID
	  JOIN Sales.SalesOrderDetail
	    ON SalesOrderHeader.SalesOrderID = SalesOrderDetail.SalesOrderID
	  GROUP BY Person.CountryRegion.Name, City
UNION ALL 
SELECT NULL AS Country,
       NULL City,
       NULL AS nYear, 
       MONTH(OrderDate) AS nMonth, 
       SUM(SubTotal) AS TotalSales,
       AVG(SubTotal) AS AvgSale,
       COUNT(SubTotal) AS NumSales      
	FROM Sales.SalesOrderHeader
	  JOIN Sales.SalesOrderDetail
	    ON SalesOrderHeader.SalesOrderID = SalesOrderDetail.SalesOrderID
	GROUP BY MONTH(OrderDate)
UNION ALL 
SELECT NULL AS Country,
       NULL AS City,
       YEAR(OrderDate) AS nYear, 
       NULL AS nMonth, 
       SUM(SubTotal) AS TotalSales,
       AVG(SubTotal) AS AvgSale,
       COUNT(SubTotal) AS NumSales      
	FROM Sales.SalesOrderHeader
	  JOIN Sales.SalesOrderDetail
	    ON SalesOrderHeader.SalesOrderID = SalesOrderDetail.SalesOrderID
	  GROUP BY YEAR(OrderDate)		
	  ORDER BY Country, City, nYear, nMonth  