IF NOT DBUSED("Northwind")
	OPEN DATABASE HOME(2) + "Northwind\Northwind"
ENDIF 

* Base data
SELECT Country, ;
       City, ;
       YEAR(OrderDate) AS OrderYear, ;
       MONTH(OrderDate) AS OrderMonth, ;
       SUM(Quantity * OrderDetails.UnitPrice) AS nTotal, ;
       AVG(Quantity * OrderDetails.UnitPrice) AS nAvg, ;
       COUNT(*) AS nCount ;
	FROM Customers ;
	  JOIN Orders ;
	    ON Customers.CustomerID = Orders.CustomerID ;
	  JOIN OrderDetails ;
	    ON Orders.OrderID = OrderDetails.OrderID ;
	GROUP BY OrderYear, OrderMonth, Country, City ;
	ORDER BY Country, City, OrderYear, OrderMonth ;
	INTO CURSOR csrCtyTotals

* Now year totals by city
SELECT Country, City, OrderYear, ;
       999 as OrderMonth, ;
       SUM(nTotal) AS nTotal, ;
       SUM(nTotal)/SUM(nCount) AS nAvg, ;
       SUM(nCount) AS nCount ;
	FROM csrCtyTotals ;
	GROUP BY Country, City, OrderYear ;
	INTO CURSOR csrYearTotals
	
* Now city totals 
SELECT Country, City, ;
       99999 AS OrderYear, ;
       999 as OrderMonth, ;
       SUM(nTotal) AS nTotal, ;
       SUM(nTotal)/SUM(nCount) AS nAvg, ;
       SUM(nCount) AS nCount ;
	FROM csrCtyTotals ;
	GROUP BY Country, City ;
	INTO CURSOR csrCityTotals
	
* Now country totals
SELECT Country, ;
       REPLICATE('Z', 15) AS City, ;
       99999 AS OrderYear, ;
       999 as OrderMonth, ;
       SUM(nTotal) AS nTotal, ;
       SUM(nTotal)/SUM(nCount) AS nAvg, ;
       SUM(nCount) AS nCount ;
	FROM csrCtyTotals ;
	GROUP BY Country ;
	INTO CURSOR csrCountryTotals
	
* Now grand total
SELECT REPLICATE('Z', 15) AS Country, ;
       REPLICATE('Z', 15) AS City, ;
       99999 AS OrderYear, ;
       999 as OrderMonth, ;
       SUM(nTotal) AS nTotal, ;
       SUM(nTotal)/SUM(nCount) AS nAvg, ;
       SUM(nCount) AS nCount ;
	FROM csrCtyTotals ;
	INTO CURSOR csrGrandTotal
	
* Create one cursor
SELECT * ;
	FROM csrCtyTotals ;
UNION ALL ;
SELECT * ;
	FROM csrYearTotals ;
UNION ALL ;
SELECT * ;
	FROM csrCityTotals ;
UNION ALL ;
SELECT * ;
	FROM csrCountryTotals ;
UNION ALL ;
SELECT * ;
	FROM csrGrandTotal ;
  ORDER BY Country, City, OrderYear, OrderMonth ;
  INTO CURSOR csrWithGroupTotals READWRITE 
  
UPDATE csrWithGroupTotals ;
	SET OrderMonth = .null. ;
	WHERE OrderMonth = 999
	
UPDATE csrWithGroupTotals ;
	SET OrderYear = .null. ;
	WHERE OrderYear = 99999
	
UPDATE csrWithGroupTotals ;
	SET City = .null. ;
	WHERE City = REPLICATE('Z', 15)

UPDATE csrWithGroupTotals ;
	SET Country = .null. ;
	WHERE Country = REPLICATE('Z', 15)