IF NOT DBUSED("Northwind")
	OPEN DATABASE HOME(2) + "Northwind\Northwind"
ENDIF 

SELECT Country, ;
       City, ;
       YEAR(OrderDate) AS OrderYear, ;
       MONTH(OrderDate) AS OrderMonth, ;
       SUM(Quantity * OrderDetails.UnitPrice) AS nTotal, ;
       AVG(Quantity * OrderDetails.UnitPrice) AS nAvg, ;
       COUNT(*) AS nCount ;
	FROM Customers ;
	  JOIN Orders ;
	    ON Customers.CustomerID = Orders.CustomerID ;
	  JOIN OrderDetails ;
	    ON Orders.OrderID = OrderDetails.OrderID ;
	GROUP BY OrderYear, OrderMonth, Country, City ;
	ORDER BY Country, City, OrderYear, OrderMonth ;
	INTO CURSOR csrCtyTotals
	
LOCAL nYearTotal, nCityTotal, nCountryTotal, nGrandTotal
LOCAL nYearCnt, nCityCnt, nCountryCount, nGrandCount
LOCAL nCurYear, cCurCity, cCurCountry

* Create a new cursor to hold the results
SELECT * ;
	FROM csrCtyTotals ;
	WHERE .F. ;
	INTO CURSOR csrWithGroupTotals READWRITE 
	
SELECT csrCtyTotals
STORE 0 TO nYearTotal, nCityTotal, nCountryTotal, nGrandTotal
STORE 0 TO nYearCount, nCityCount, nCountryCount, nGrandCount
nCurYear = csrCtyTotals.OrderYear
cCurCity = csrCtyTotals.City
cCurCountry = csrCtyTotals.Country

SCAN
	* First check for end of year,
	* but could be same year and change of city or country.
	IF csrCtyTotals.OrderYear <> m.nCurYear OR ;
	   NOT (csrCtyTotals.City == m.cCurCity) OR ;
	   NOT (csrCtyTotals.Country == m.cCurCountry)
		INSERT INTO csrWithGroupTotals ;
			VALUES (m.cCurCountry, m.cCurCity, m.nCurYear, .null., ;
			        m.nYearTotal, m.nYearTotal/m.nYearCount, m.nYearCount)
		m.nCurYear = csrCtyTotals.OrderYear
		STORE 0 TO m.nYearTotal, m.nYearCount
		
		* Now check for change of city
		IF NOT (csrCtyTotals.City == m.cCurCity) OR ;
	       NOT (csrCtyTotals.Country == m.cCurCountry) 
	    	INSERT INTO csrWithGroupTotals ;
	        	VALUES (m.cCurCountry, m.cCurCity, .null., .null., ;
	        	        m.nCityTotal, m.nCityTotal/m.nCityCount, m.nCityCount)
	        m.cCurCity = csrCtyTotals.City
	        STORE 0 TO m.nCityTotal, m.nCityCount
	        
	        * Now check for change of country
	        IF NOT (csrCtyTotals.Country == m.cCurCountry)
	        	INSERT INTO csrWithGroupTotals ;
	        		VALUES (m.cCurCountry, .null., .null., .null., ;
	        		        m.nCountryTotal, m.nCountryTotal/m.nCountryCount, m.nCountryCount)
	        	m.cCurCountry = csrCtyTotals.Country
	        	STORE 0 TO m.nCountryTotal, m.CountryCount
	        ENDIF
	    ENDIF 
	ENDIF 
	
	* Now handle current record
	INSERT INTO csrWithGroupTotals ;
		VALUES (csrCtyTotals.Country, csrCtyTotals.City, ;
		        csrCtyTotals.OrderYear, csrCtyTotals.OrderMonth, ;
		        csrCtyTotals.nTotal, csrCtyTotals.nAvg, ;
		        csrCtyTotals.nCount)
	nYearTotal = m.nYearTotal + csrCtyTotals.nTotal
	nYearCount = m.nYearCount + csrCtyTotals.nCount
	nCityTotal = m.nCityTotal + csrCtyTotals.nTotal 
	nCityCount = m.nCityCount + csrCtyTotals.nCount
	nCountryTotal = m.nCountryTotal + csrCtyTotals.nTotal 
	nCountryCount = m.nCountryCount + csrCtyTotals.nCount
	nGrandTotal = m.nGrandTotal + csrCtyTotals.nTotal
	nGrandCount = m.nGrandCount + csrCtyTotals.nCount
	
ENDSCAN 

* Now insert grand totals
INSERT INTO csrWithGroupTotals ;
	VALUES (.null., .null., .null., .null., ;
	        m.nGrandTotal, m.nGrandTotal/m.nGrandCount, m.nGrandCount)


USE IN SELECT("csrCtyTotals")

SELECT csrWithGroupTotals
RETURN 